#!/bin/sh
#
# Runs the given component ini file.
#

. ${HOME}/.cocomposerc
JAVA="java"
CLASSPATH="${COCOMPOSE_HOME}/output/SEESCOA/component.jar:${COCOMPOSE_HOME}/output/SEESCOA/controller.jar:../Util:."
RUN="${JAVA} -classpath ${CLASSPATH} component.system.ComponentSystem component:testcases.scss.Controller:Controller:"

if [ "$1" = "" ]; then
	echo "Usage: runcomponent <ComponentConfig.ini>"
else
	CFG_FILE="`pwd`/$1" > /dev/null 2> /dev/null
	${RUN}${CFG_FILE}
	#messages:trace\
	#-Xrunhprof:heap=sites,file=test.txt \
fi
