package testcases.scss;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import javax.swing.*; 

public class TestCanvas extends JPanel {
	private Image image;
	private Dimension prefer; 

	public TestCanvas(){
		super();
		image = null;
		prefer = null; 
	}

	public void setImage(Image image){
		this.image = image;

		int height = image.getHeight(null);
		int width  = image.getWidth(null);
		prefer = new Dimension(width, height); 
		repaint();
	}

 	public void repaint(Graphics g){
		paint(g); 
 	}

	public Dimension getPreferredSize(){
		return prefer; 
	}

	public void paint(Graphics g){
		if(image!=null)
			g.drawImage(image, 0, 0, this);
	}
}
