package testcases.scss;

import java.awt.*;
import java.net.*;
import javax.swing.*; 
import java.awt.event.*; 

public class TestFrame extends JFrame implements WindowListener {

	public TestCanvas c;

	TestFrame(String titel){
		c = new TestCanvas();
		getContentPane().add(c);
		addWindowListener(this); 
		this.setTitle(titel);
	}

	public void update(Graphics g){
		paint(g); 
	}

	public void setImage(Image image){
		c.setImage(image);
		pack();
	}

	public void windowActivated(WindowEvent e)   { System.err.println("windowActivated");   }
	public void windowClosed(WindowEvent e)      { System.err.println("windowClosed");      }
	public void windowClosing(WindowEvent e)     { System.err.println("windowClosing");     }
	public void windowDeactivated(WindowEvent e) { System.err.println("windowDeactivated"); }
	public void windowDeiconified(WindowEvent e) { System.err.println("windowDeiconified"); }
	public void windowIconified(WindowEvent e)   { System.err.println("windowIconified");   }
	public void windowOpened(WindowEvent e)      { System.err.println("windowOpened");      }
}
