<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

  <xsl:output method="text"/>
  <xsl:output indent="yes"/>
  <xsl:strip-space elements = "*"/>

  <xsl:template match="component">
    package testcases.scss;
    import java.net.*;
    import java.io.*;

    <xsl:apply-templates select="description"/>

    componentclass <xsl:value-of select="@name"/> {

    <xsl:for-each select="port">
      <xsl:apply-templates select="description"/>
      <xsl:if test="@type='multi'">multi</xsl:if>port <xsl:value-of select="@name"/>;
    </xsl:for-each>

    public <xsl:value-of select="@name"/>(){
    super();
    <xsl:for-each select="port">
      <xsl:value-of select="@name"/> = create<xsl:if test="@type='multi'">Multi</xsl:if>Port("<xsl:value-of select="@name"/>");
    </xsl:for-each>
    }
    <xsl:apply-templates select="port"/>
    }
  </xsl:template>

  <xsl:template match="port">
    <xsl:apply-templates select="syntactic"/>
  </xsl:template>

  <xsl:template match="description">
    /*<xsl:value-of select="."/>*/
  </xsl:template>

  <xsl:template match="message">
    <xsl:apply-templates select="description"/>

    /*<xsl:value-of select="@type"/><xsl:if test="@type='in'">*/</xsl:if> message <xsl:value-of select="@name"/>(<xsl:choose><xsl:when test="count(child::*)!=0"><xsl:apply-templates/></xsl:when></xsl:choose>){
    } <xsl:if test="@type='out'">*/</xsl:if>
  </xsl:template>

  <xsl:template match="argument">
    <xsl:value-of select="."/><xsl:text> </xsl:text><xsl:value-of select="@name"/>
    <xsl:if test="position()!=last()">, </xsl:if>
  </xsl:template>

</xsl:stylesheet>
