package testcases.scss.motiondetection;	

public class Detector {

    private VideoImage $referenceFrame;
    private Sensitivity $sensitivity;
    private Hotspot $hotspot;
    private int j;

    public Detector(){
	
    }

    public boolean detect(VideoImage image){
	return false;
    }

    public void setSensitivity(Sensitivity sensitivity){
	$sensitivity = sensitivity;
    }

    public Sensitivity getSensitivity(){
	return $sensitivity;
    }
    
    public void setReferenceFrame(VideoImage refFrame){
	if($referenceFrame == null){
	    $referenceFrame = new VideoImage(refFrame.getWidth(), 
					     refFrame.getHeight(),
					     refFrame.getFormat(),
					     refFrame.getBytesPerPixel());
	}
	$referenceFrame.setNewVideoData(refFrame);
    }
    
    public VideoImage getReferenceFrame(){
	return $referenceFrame;
    }

    public void setHotspot(Hotspot hotspot){
	$hotspot = hotspot;
    }

    public Hotspot getHotspot(){
	if($hotspot == null){
	    if(getReferenceFrame() != null){
		setHotspot(new Hotspot(0, 0, 
				       getReferenceFrame().getWidth()-1, 
				       getReferenceFrame().getHeight()-1));
	    }else{
		setHotspot(new Hotspot(0, 0, 0, 0));
	    }
	}
	return $hotspot;
    }

}
