package testcases.scss.motiondetection;	


public class Hotspot{

    private int $x;
    private int $y;
    private int $width;
    private int $height;

    public Hotspot(int x, int y, int width, int height){
	if(x >= 0){
	    $x = x;
	}else{
	    $x = 0;
	}
	if(y >= 0){
	    $y = y;
	}else{
	    $y = 0;
	}
	if(width >= 0){
	    $width = width;
	}else{
	    $width = 0;
	}
	if(height >=0){
	    $height = height;
	}else{
	    $height = 0;
	}
    }

    public int getX(){
	return $x;
    }
    public int getY(){
	return $y;
    }
    public int getWidth(){
	return $width;
    }
    public int getHeight(){
	return $height;
    }

    public int numberOfPixels(){
	return getWidth()*getHeight();
    }

    public String toString(){
	return ("x: "+ $x + "  y: " + $y + "  width: "+$width+"  height: "+$height);
    }

}
