package testcases.scss.motiondetection;

public class HotspotMDCommand extends MDCommand{

    public HotspotMDCommand(CameraMD cMD){
	super(cMD);
    }

    public void execute(Object o){
	try{
	    super.execute(o);
	    Integer[] iV = (Integer[])o;	    
	    getCameraMD().setHotspot(new Hotspot(iV[0].intValue(),
						 iV[1].intValue(),
						 iV[2].intValue(),
						 iV[2].intValue()));

	}catch(ClassCastException cce){
	    // the specs weren't followed... just return
	    return;
	}catch(ArrayIndexOutOfBoundsException aioobe){
	    // the specs weren't followed... just return
	    return;
	}
    }

    public Object getValue(){
	Integer[] iV = new Integer[4];
	iV[0] = new Integer(getCameraMD().getHotspot().getX());
	iV[1] = new Integer(getCameraMD().getHotspot().getY());
	iV[2] = new Integer(getCameraMD().getHotspot().getWidth());
	iV[3] = new Integer(getCameraMD().getHotspot().getHeight());
	return iV;
    }

    public String toString(){
	return "Hotspot Command";
    }

}
