package testcases.scss.motiondetection;

public class ReferenceMDCommand extends MDCommand{

    public ReferenceMDCommand(CameraMD cMD){
	super(cMD);
    }

    public void execute(Object o){
	try{
	    String s = (String)o;
	    if(s.equals("static")){
		getCameraMD().setEvolvable(false);
	    }else if(s.equals("evolvable")){
		getCameraMD().setEvolvable(true);
	    }
	}catch(ClassCastException cce){
	    // the specs weren't followed... just return
	    return;
	}
    }

    public Object getValue(){
	if(getCameraMD().evolvable()){
	    return new String("evolvable");
	}else{
	    return new String("static");
	}
    }

}
