package testcases.scss.motiondetection.testcomponent;

import javax.swing.*;
import java.awt.*;
import testcases.scss.motiondetection.*;
import java.awt.geom.*;

public class HotspotCanvas extends JPanel {

    private Hotspot $hotspot;
    private boolean $changed = false;
    
    public HotspotCanvas(){
	super();
	setOpaque(false);
    }

    public void setHotspot(Hotspot hotspot){
	$hotspot = hotspot;
	$changed = true;
    }

    public Hotspot getHotspot(){
	return $hotspot;
    }

    public void paint(Graphics g){
	if($changed){
	    
	    $changed = false;
	}

	Graphics2D g2 = (Graphics2D)g;

	if($hotspot != null){
	    g2.setColor(Color.red);
	    g2.draw(new Rectangle2D.Double($hotspot.getX(), $hotspot.getY(), 
					   $hotspot.getWidth(), $hotspot.getHeight()));
	}
    }

}
