/* Component Parser Version 1.7 -- Generated Code */
package testcases.scss.storage;
import component.system.*;
import testcases.scss.util.TimeData;
import testcases.scss.util.ID;
import testcases.scss.util.StorageVideoImage;
import testcases.scss.util.AlarmData;
import testcases.scss.util.EventData;

public class InOut extends StoragePort

{public InOut ( Storage c){super(c); }public synchronized void  SaveImage(Port port, Message inmessage, Message outmessage) 
{
System.out.println("InOut  SaveImage --- Storage");
checkListener();
component.listener.insertImage(((StorageVideoImage)inmessage.getField("Image")));}
 public synchronized void  SaveEvent(Port port, Message inmessage, Message outmessage) 
{
checkListener();
component.listener.insertEvent(((EventData)inmessage.getField("Event")));}
 public synchronized void  SaveAlarm(Port port, Message inmessage, Message outmessage) 
{
checkListener();
component.listener.insertAlarm(((AlarmData)inmessage.getField("Alarm")));}
 public synchronized void  QueryAlarm(Port port, Message inmessage, Message outmessage) 
{
checkListener();
 AlarmData ad = component.listener.queryAlarm(((TimeData)inmessage.getField("Time")), ((ID)inmessage.getField("CameraId")));
{ outmessage.putField("Invoke","PutAlarm");
outmessage.putField("Alarm",ad);
(component.InOut).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 public synchronized void  QueryEvent(Port port, Message inmessage, Message outmessage) 
{
checkListener();
 EventData ev = component.listener.queryEvent(((TimeData)inmessage.getField("Time")), ((ID)inmessage.getField("ComponentId")));
{ outmessage.putField("Invoke","PutEvent");
outmessage.putField("Event",ev);
(component.InOut).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 public synchronized void  QueryImage(Port port, Message inmessage, Message outmessage) 
{
checkListener();
 StorageVideoImage vi = component.listener.queryImage(((TimeData)inmessage.getField("Time")), ((ID)inmessage.getField("CameraId")));
{ outmessage.putField("Invoke","PutImage");
outmessage.putField("Image",vi);
(component.InOut).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 public synchronized void  PutImage(Port port, Message inmessage, Message outmessage) 
{
}
 public synchronized void  PutEvent(Port port, Message inmessage, Message outmessage) 
{
}
 public synchronized void  PutAlarm(Port port, Message inmessage, Message outmessage) 
{
}
 private void checkListener () 
{
if (component.listener==null)
if (StorageController.listener!=null)
component.listener=StorageController.listener;
else {
System.out.println("listener not initialised");
System.exit(0);}
}
 }

;