/* Component Parser Version 1.7 -- Generated Code */
package testcases.scss.storage;
import component.system.*;
import java.util.GregorianCalendar;
import java.util.Stack;
import java.io.InputStream;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;
import uibuilder.backend.WidgetReferencer;
import uibuilder.widgets.widgetdata.UiObjectData;
import uibuilder.widgets.widgetdata.Data;
import uibuilder.widgets.widgetdata.StringData;
import uibuilder.widgets.widgetdata.RangeData;
import uibuilder.widgets.widgetdata.ImageData;
import uibuilder.widgets.widgetdata.NoDataException;
import testcases.scss.util.TimeData;
import testcases.scss.util.ID;
import testcases.scss.util.CanvasImageCreationStrategy;
import testcases.scss.util.StorageVideoImage;
import testcases.scss.util.AlarmData;
import testcases.scss.util.EventData;

 class Generator_3 implements Runnable

{ public Port  VideoStreamUpdate; int red = 0, green = 0, blue = 0, width = 320, height = 240;private Thread GeneratorThread = null;public void start ( Port OutputStream) 
{
if (GeneratorThread==null)
{
VideoStreamUpdate=OutputStream;
GeneratorThread=new Thread (this, "Generator_3");
GeneratorThread.start();}
}
 public void run () 
{
 byte[] image;
 StorageVideoImage svi;
 ID camid = new ID ("1");
 Message inmessage = new Message ();
 Message outmessage = new Message (inmessage);
while( true)
{
try 
{
java.lang.Thread.sleep(1000);
image=new byte [width*height*3];
for( int i = 0;i<width*height*3;i+=3){
image[i+0]=(byte)red;
image[i+1]=(byte)green++;
image[i+2]=(byte)blue++;
blue+=10;}

red+=50;
svi=new StorageVideoImage ();
svi.setImage(width, height, true, image);
svi.setCameraID(camid);
{ outmessage.putField("Invoke","SaveImage");
outmessage.putField("Image",svi);
(VideoStreamUpdate).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
catch ( Exception e)
{
e.printStackTrace();}
}
}
 }

;
 class Generator_1 implements Runnable

{ public Port  VideoStreamUpdate; int grey = 0, width = 320, height = 240;private Thread GeneratorThread = null;public void start ( Port OutputStream) 
{
if (GeneratorThread==null)
{
VideoStreamUpdate=OutputStream;
GeneratorThread=new Thread (this, "Generator_1");
GeneratorThread.start();}
}
 public void run () 
{
 byte[] image;
 StorageVideoImage svi;
 ID camid = new ID ("1");
 Message inmessage = new Message ();
 Message outmessage = new Message (inmessage);
while( true)
{
try 
{
java.lang.Thread.sleep(1000);
image=new byte [width*height];
for( int i = 0;i<width*height;i++){
image[i]=(byte)grey++;}

grey++;
svi=new StorageVideoImage ();
svi.setImage(width, height, false, image);
svi.setCameraID(camid);
{ outmessage.putField("Invoke","SaveImage");
outmessage.putField("Image",svi);
(VideoStreamUpdate).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
catch ( Exception e)
{
e.printStackTrace();}
}
}
 }

;
 public class StorageControllerClient extends component.system.Component

{private String $platform = "AWT";private WidgetReferencer $widgets = null;private Generator_3 gen = new Generator_3 ();public Port Component; public Port  UiDescription; public Port  UiOut; public Port  QueryStorage; public Port  VideoIn; public Port  DataIn; public Port  VideoRecordOut; public Port  EventLogOut;public StorageControllerClient (){super(); Component=createPort("Component"); UiDescription=createPort("UiDescription"); UiOut=createPort("UiOut"); QueryStorage=createPort("QueryStorage"); VideoIn=createPort("VideoIn"); DataIn=createPort("DataIn"); VideoRecordOut=createPort("VideoRecordOut"); EventLogOut=createPort("EventLogOut"); }public synchronized void  Init(Port port, Message inmessage, Message outmessage) 
{
{ outmessage.putField("Invoke","GetUiDescription");
(UiDescription).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;
 TimeData time = new TimeData (2002, 2, 12, 3, 2, 25, 15);
 ID camid = new ID ("1");
 BufferedImage img = new BufferedImage (300, 200, BufferedImage.TYPE_INT_RGB);
 Graphics2D g = img.createGraphics();
g.setColor(Color.red);
g.setBackground(Color.white);
g.fill3DRect(20, 20, 260, 160, true);
g.draw3DRect(20, 20, 260, 160, true);
g.dispose();
 StorageVideoImage image = new StorageVideoImage (time, camid, img);
outmessage.putField("Image",image);
{ outmessage.putField("Invoke","SaveImage");
(VideoRecordOut).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;
 AlarmData alarm = new AlarmData (time, camid, "Test alarm");
outmessage.putField("Alarm",alarm);
{ outmessage.putField("Invoke","SaveAlarm");
(VideoRecordOut).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;
 ID compid = new ID ("1");
 EventData event = new EventData (time, compid, "Test event");
outmessage.putField("Event",event);
{ outmessage.putField("Invoke","SaveEvent");
(EventLogOut).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;
gen.start(VideoRecordOut);}
 public synchronized void  UiDescription(Port port, Message inmessage, Message outmessage) 
{
 String uiString = ((String)inmessage.getField("UiString"));
 int i;
 String classname = this.getClass().getName();
while( (i = uiString.indexOf("<ClientClass>"))>-1)
{
uiString=uiString.substring(0, i)+classname+uiString.substring(i+13);}

outmessage.putField("UiString",uiString);
outmessage.putField("Platform",$platform);
outmessage.putField("ActionHandler",this);
{ outmessage.putField("Invoke","UiIn");
(UiOut).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 public synchronized void  ReceiveWidgetReferencer(Port port, Message inmessage, Message outmessage) 
{
System.out.println("WidgetReferencer received at "+this);
$widgets=((WidgetReferencer)inmessage.getField("Widgets"));}
 public synchronized void  SendImage(Port port, Message inmessage, Message outmessage) 
{
try 
{
 StorageVideoImage image = ((StorageVideoImage)inmessage.getField("Image"));
 UiObjectData msg = (UiObjectData)$widgets.getWidget("outMessage");
 StringData msgStr = (StringData)msg.getData();
 UiObjectData time = (UiObjectData)$widgets.getWidget("outTime");
 StringData timeStr = (StringData)time.getData();
 UiObjectData ms = (UiObjectData)$widgets.getWidget("outMSecond");
 StringData msStr = (StringData)ms.getData();
if (image==null)
{
msgStr.setStringData("<No image found>");
timeStr.setStringData("");
msStr.setStringData("");}

else {
 UiObjectData canvas = (UiObjectData)$widgets.getWidget("outCanvas");
 ImageData canvasImg = (ImageData)canvas.getData();
canvasImg.setImageData(image.getImage());
msgStr.setStringData("");
timeStr.setStringData(String.valueOf(image.getTime()));
msStr.setStringData(String.valueOf(image.getMilliSec()));
canvas.updateWidgetFromData();}

msg.updateWidgetFromData();
time.updateWidgetFromData();
ms.updateWidgetFromData();}
catch ( Exception e)
{
e.printStackTrace();}
}
 public synchronized void  SendEvent(Port port, Message inmessage, Message outmessage) 
{
try 
{
 EventData event = ((EventData)inmessage.getField("Event"));
 UiObjectData msg = (UiObjectData)$widgets.getWidget("outMessage");
 StringData msgStr = (StringData)msg.getData();
 UiObjectData time = (UiObjectData)$widgets.getWidget("outTime");
 StringData timeStr = (StringData)time.getData();
 UiObjectData ms = (UiObjectData)$widgets.getWidget("outMSecond");
 StringData msStr = (StringData)ms.getData();
if (event==null)
{
msgStr.setStringData("<No event found>");
timeStr.setStringData("");
msStr.setStringData("");}

else {
msgStr.setStringData(event.getComment());
timeStr.setStringData(String.valueOf(event.getTime()));
msStr.setStringData(String.valueOf(event.getMilliSec()));}

msg.updateWidgetFromData();
time.updateWidgetFromData();
ms.updateWidgetFromData();}
catch ( Exception e)
{
e.printStackTrace();}
}
 public synchronized void  SendAlarm(Port port, Message inmessage, Message outmessage) 
{
try 
{
 AlarmData alarm = ((AlarmData)inmessage.getField("Alarm"));
 UiObjectData msg = (UiObjectData)$widgets.getWidget("outMessage");
 StringData msgStr = (StringData)msg.getData();
 UiObjectData time = (UiObjectData)$widgets.getWidget("outTime");
 StringData timeStr = (StringData)time.getData();
 UiObjectData ms = (UiObjectData)$widgets.getWidget("outMSecond");
 StringData msStr = (StringData)ms.getData();
if (alarm==null)
{
msgStr.setStringData("<No alarm found>");
timeStr.setStringData("");
msStr.setStringData("");}

else {
msgStr.setStringData(alarm.getDescription());
timeStr.setStringData(String.valueOf(alarm.getTime()));
msStr.setStringData(String.valueOf(alarm.getMilliSec()));}

msg.updateWidgetFromData();
time.updateWidgetFromData();
ms.updateWidgetFromData();}
catch ( Exception e)
{
e.printStackTrace();}
}
 public synchronized void  UiIn(Port port, Message inmessage, Message outmessage) 
{
}
 public synchronized void  GetUiDescription(Port port, Message inmessage, Message outmessage) 
{
}
 public synchronized void  QueryImage(Port port, Message inmessage, Message outmessage) 
{
}
 public synchronized void  QueryEvent(Port port, Message inmessage, Message outmessage) 
{
}
 public synchronized void  QueryAlarm(Port port, Message inmessage, Message outmessage) 
{
}
 public synchronized void  SaveImage(Port port, Message inmessage, Message outmessage) 
{
}
 public synchronized void  SaveAlarm(Port port, Message inmessage, Message outmessage) 
{
}
 public synchronized void  SaveEvent(Port port, Message inmessage, Message outmessage) 
{
}
 public static void exit () 
{
System.exit(0);}
 public void fwQueryImage ( String[] ports,  Stack params) throws uibuilder.widgets.widgetdata.NoDataException 
{
 Message inmessage = new Message ();
 Message outmessage = new Message (inmessage);
 TimeData time = createTimeData(params);
 ID camid = createID(params);
for( int i = 0;i<ports.length;i++){
System.out.println("Sending message QueryImage to port "+ports[i]);
{ outmessage.putField("Invoke","QueryImage");
outmessage.putField("Time",time);
outmessage.putField("CameraId",camid);
(getPortByName(ports[i])).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
}
 public void fwQueryAlarm ( String[] ports,  Stack params) throws uibuilder.widgets.widgetdata.NoDataException 
{
 Message inmessage = new Message ();
 Message outmessage = new Message (inmessage);
 TimeData time = createTimeData(params);
 ID camid = createID(params);
for( int i = 0;i<ports.length;i++){
System.out.println("Sending message QueryAlarm to port "+ports[i]);
{ outmessage.putField("Invoke","QueryAlarm");
outmessage.putField("Time",time);
outmessage.putField("CameraId",camid);
(getPortByName(ports[i])).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
}
 public void fwQueryEvent ( String[] ports,  Stack params) throws uibuilder.widgets.widgetdata.NoDataException 
{
 Message inmessage = new Message ();
 Message outmessage = new Message (inmessage);
 TimeData time = createTimeData(params);
 ID compid = createID(params);
for( int i = 0;i<ports.length;i++){
System.out.println("Sending message QueryEvent to port "+ports[i]);
{ outmessage.putField("Invoke","QueryEvent");
outmessage.putField("Time",time);
outmessage.putField("ComponentId",compid);
(getPortByName(ports[i])).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
}
 public void fwMessage ( String type,  String[] ports,  Stack params) 
{
try 
{
if (type.equals("QueryImage"))
{
fwQueryImage(ports, params);}

else if (type.equals("QueryAlarm"))
{
fwQueryAlarm(ports, params);}

else if (type.equals("QueryEvent"))
{
fwQueryEvent(ports, params);}
}
catch ( Exception e)
{
e.printStackTrace();}
}
 public void fwMessage ( String type,  String[] ports,  UiObjectData param1,  UiObjectData param2,  UiObjectData param3,  UiObjectData param4,  UiObjectData param5,  UiObjectData param6,  UiObjectData param7,  UiObjectData param8) 
{
 Stack params = new Stack ();
params.push(param8);
params.push(param7);
params.push(param6);
params.push(param5);
params.push(param4);
params.push(param3);
params.push(param2);
params.push(param1);
fwMessage(type, ports, params);}
 public void fwMessage ( String type,  String[] ports,  UiObjectData param1,  UiObjectData param2,  UiObjectData param3,  UiObjectData param4,  UiObjectData param5,  UiObjectData param6,  UiObjectData param7) 
{
 Stack params = new Stack ();
params.push(param7);
params.push(param6);
params.push(param5);
params.push(param4);
params.push(param3);
params.push(param2);
params.push(param1);
fwMessage(type, ports, params);}
 public void fwMessage ( String type,  String[] ports,  UiObjectData param1,  UiObjectData param2,  UiObjectData param3,  UiObjectData param4,  UiObjectData param5,  UiObjectData param6) 
{
 Stack params = new Stack ();
params.push(param6);
params.push(param5);
params.push(param4);
params.push(param3);
params.push(param2);
params.push(param1);
fwMessage(type, ports, params);}
 public void fwMessage ( String type,  String[] ports,  UiObjectData param1,  UiObjectData param2,  UiObjectData param3,  UiObjectData param4,  UiObjectData param5) 
{
 Stack params = new Stack ();
params.push(param5);
params.push(param4);
params.push(param3);
params.push(param2);
params.push(param1);
fwMessage(type, ports, params);}
 public void fwMessage ( String type,  String[] ports,  UiObjectData param1,  UiObjectData param2,  UiObjectData param3,  UiObjectData param4) 
{
 Stack params = new Stack ();
params.push(param4);
params.push(param3);
params.push(param2);
params.push(param1);
fwMessage(type, ports, params);}
 public void fwMessage ( String type,  String[] ports,  UiObjectData param1,  UiObjectData param2,  UiObjectData param3) 
{
 Stack params = new Stack ();
params.push(param3);
params.push(param2);
params.push(param1);
fwMessage(type, ports, params);}
 public void fwMessage ( String type,  String[] ports,  UiObjectData param1,  UiObjectData param2) 
{
 Stack params = new Stack ();
params.push(param2);
params.push(param1);
fwMessage(type, ports, params);}
 public void fwMessage ( String type,  String[] ports,  UiObjectData param1) 
{
 Stack params = new Stack ();
params.push(param1);
fwMessage(type, ports, params);}
 public void fwMessage ( String type,  String[] ports) 
{
 Stack params = new Stack ();
fwMessage(type, ports, params);}
 private TimeData createTimeData ( Stack params) throws uibuilder.widgets.widgetdata.NoDataException 
{
 int day = ((RangeData)((UiObjectData)params.pop()).getData()).getRangeData();
 int month = ((RangeData)((UiObjectData)params.pop()).getData()).getRangeData();
 int year = ((RangeData)((UiObjectData)params.pop()).getData()).getRangeData();
 int hour = ((RangeData)((UiObjectData)params.pop()).getData()).getRangeData();
 int minute = ((RangeData)((UiObjectData)params.pop()).getData()).getRangeData();
 int second = ((RangeData)((UiObjectData)params.pop()).getData()).getRangeData();
 int msecond = ((RangeData)((UiObjectData)params.pop()).getData()).getRangeData();
 TimeData time = new TimeData (year, month, day, hour, minute, second, msecond);
return time;}
 private ID createID ( Stack params) throws uibuilder.widgets.widgetdata.NoDataException 
{
 String idstr = ((StringData)((UiObjectData)params.pop()).getData()).getStringData();
return new ID (idstr);}
 }
;