# SQL script for creating the SEESCOA storage database
# and creating a "seescoa" user with password "seescoa"
#
# Authors: Miro Casanova, Dennis Wagelaar
# Date:    14 October 2002

## MySQL Database creation

CREATE DATABASE storage;

## New User creation

GRANT USAGE ON *.* TO seescoa@localhost;
GRANT USAGE ON *.* TO seescoa@thishost;

SET PASSWORD FOR seescoa@localhost = PASSWORD('seescoa');
SET PASSWORD FOR seescoa@thishost = PASSWORD('seescoa');

## Adding privileges to the user for storage database

GRANT ALL PRIVILEGES ON storage.* TO seescoa;

FLUSH PRIVILEGES;
