/* Component Parser Version 1.7 -- Generated Code */
package testcases.scss.util.test;
import component.system.*;
import java.lang.*;
import java.io.*;
import java.util.*;

 class TesterOut
{TesterOut (){}public synchronized void  SaveImage(Port port, Message inmessage, Message outmessage) 
{
}
 public synchronized void  QueryImage(Port port, Message inmessage, Message outmessage) 
{
}
 public synchronized void  QueryEvent(Port port, Message inmessage, Message outmessage) 
{
}
 public synchronized void  QueryAlarm(Port port, Message inmessage, Message outmessage) 
{
}
 }

;
 class TesterIn
{private TesterForStorage component;private String outputpath = "/tmp/";private String extension = ".jpg";TesterIn ( TesterForStorage c){component=c; }public synchronized void  SendData(Port port, Message inmessage, Message outmessage) 
{
 String fname = this.outputpath;
fname=fname+Long.toString(((VideoImage)inmessage.getField("Data")).getTime().getTime());
fname=fname+Integer.toString(((VideoImage)inmessage.getField("Data")).getTime().getMilliSec());
fname=fname+Long.toString(((VideoImage)inmessage.getField("Data")).getID().getID());
try 
{
 RandomAccessFile f2 = new RandomAccessFile (fname, "rw");
f2.write(((VideoImage)inmessage.getField("Data")).getImage());
f2.close();}
catch ( IOException e)
{
System.out.println("Error While retrieveing image");
System.exit(0);}
}
 private String[] images = {"PICT1.jpg","PICT2.jpg"};}

;
 class Aux
{public static long firstHR;public static int firstMS;public static long firstID;private boolean firstTime;private TesterForStorage component;private long[] cameras = {1001,1002,1003,1004,1005};private String inputpath = "/tmp/";private int current = 0;Aux ( TesterForStorage c){component=c; }public synchronized void  StoreImage(Port port, Message inmessage, Message outmessage) 
{
System.out.println("AUX StoreImage()");
 byte[] data = null;
 VideoImage im = new VideoImage ();
 java.lang.String pt1 = inputpath+((String)inmessage.getField("Path"));
try 
{
 RandomAccessFile ff = new RandomAccessFile (pt1, "r");
data=new byte [(int)ff.length()];
ff.readFully(data);
ff.close();
im.setImage(data);
 long camera = getCamera();
im.setID(new CameraID (new Long (camera)));
 MyCalendar gcl = new MyCalendar ();
 String year = realNumber(gcl.get(Calendar.YEAR));
 String month = realNumber(gcl.get(Calendar.MONTH)+1);
 String day = realNumber(gcl.get(Calendar.DAY_OF_MONTH));
 String hour = realNumber(gcl.get(Calendar.HOUR_OF_DAY));
 String minute = realNumber(gcl.get(Calendar.MINUTE));
 String second = realNumber(gcl.get(Calendar.SECOND));
 int mili = gcl.get(Calendar.MILLISECOND);
 String dateInString = year+month+day+hour+minute+second;
 long hr = Long.parseLong(dateInString);
if (this.firstTime)
{
this.firstHR=hr;
this.firstMS=mili;
this.firstID=camera;
this.firstTime=false;}

im.setTime(new TimeData (new Long (hr), new Integer (mili)));
{ outmessage.putField("Invoke","SaveImage");
outmessage.putField("Image",im);
(component.out).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
catch ( IOException e)
{
System.out.println("Tester file exception: File not found");
e.printStackTrace();
System.exit(0);}
}
 public synchronized void  RetrieveImage(Port port, Message inmessage, Message outmessage) 
{
 byte[] data = null;
 TimeData td = new TimeData (((Long)inmessage.getField("time")), ((Integer)inmessage.getField("ms")));
 CameraID c = new CameraID (((Long)inmessage.getField("cid")));
{ outmessage.putField("Invoke","QueryImage");
outmessage.putField("Time",td);
outmessage.putField("CameraId",c);
(component.query).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 private long getCamera () 
{
 long cm = cameras[current];
if (current==4)
current=0;
else current++;
return cm;}
 private String realNumber ( int nr) 
{
if (nr<10)
return "0"+Integer.toString(nr);
else return Integer.toString(nr);}
 }

;
 public class TesterForStorage extends component.system.Component

{private String[] images = {"PICT1.gif","PICT2.jpg"};public Port out;public Port in;public Port query;public Port aux;public TesterForStorage (){super(); out=createPort("out", new TesterOut ()); query=createPort("query", new TesterOut ()); in=createPort("in", new TesterIn (this)); aux=createPort("aux", new Aux (this)); }public synchronized void  Init(Port port, Message inmessage, Message outmessage) 
{
 int i;
System.out.println("Tester Init()");
for(i=0;i<images.length;i++){
System.out.println("Loop Init()...reading file names and calling storeImage");
{ outmessage.putField("Invoke","StoreImage");
outmessage.putField("Path",images[i]);
(aux).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;
try 
{
Thread.sleep(300);}
catch ( InterruptedException e)
{
System.out.println("Mala onda con el sleep");
System.exit(0);}
}

{ outmessage.putField("Invoke","RetrieveImage");
outmessage.putField("time",new Long (Aux.firstHR+2));
outmessage.putField("ms",new Integer (800));
outmessage.putField("cid",new Long (Aux.firstID));
(aux).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 public Data getImage ( UiObjectData djaar,  UiObjectData dmaand,  UiObjectData ddag,  UiObjectData duur,  UiObjectData dminuut) 
{
 int jaar = ((RangeData)djaar.getData()).getRangeData();
 int maand = ((RangeData)dmaand.getData()).getRangeData();
 int dag = ((RangeData)ddag.getData()).getRangeData();
 int uur = ((RangeData)dduur.getData()).getRangeData();
 int minuut = ((RangeData)dmin.getData()).getRangeData();}
 public Data storeImage ( UiObjectData path,  UiObjectData djaar,  UiObjectData dmaand,  UiObjectData ddag,  UiObjectData duur,  UiObjectData dminuut) 
{
 int jaar = ((RangeData)djaar.getData()).getRangeData();
 int maand = ((RangeData)dmaand.getData()).getRangeData();
 int dag = ((RangeData)ddag.getData()).getRangeData();
 int uur = ((RangeData)dduur.getData()).getRangeData();
 int minuut = ((RangeData)dmin.getData()).getRangeData();
 String path = ((StringData)path.getData()).getStringData();}
 }
;