
int yuv422tobw (char *YUV, char *RGB, int NumPixels) {
	asm(
			"push %%ebx\n\t"
			"push %%ecx\n\t"

			"mov %0, %%eax\n\t"
			"mov %1, %%ebx\n\t"
			"mov %2, %%ecx\n\t"
			"shr $4, %%ecx\n\t"

			"pcmpeqb %%mm7, %%mm7\n\t"   // %mm7 = FFFFFFFFFFFFFFFF
			"psllq $32, %%mm7\n\t"       // %mm7 = 00000000FFFFFFFF
				
			".align 16\n\t"
			".L99:\n\t"

			"movq   (%%eax), %%mm0\n\t"  // %mm0 = YVYUYVYU; 4 pixels
			"movq  8(%%eax), %%mm2\n\t"  // %mm2 = YVYUYVYU; 4 pixels
			"movq 16(%%eax), %%mm4\n\t"  // %mm4 = YVYUYVYU; 4 pixels
			"movq 24(%%eax), %%mm6\n\t"  // %mm6 = YVYUYVYU; 4 pixels

			// eerste 4 pixels
			"psrlw $8, %%mm0\n\t"        // %mm0 = 0Y0Y0Y0Y
			"packuswb %%mm0, %%mm1\n\t"  // %mm1 = ????YYYY
			"psrlq $32, %%mm1\n\t"	     // %mm1 = YYYY0000

			// volgende 4 pixels
			"psrlw $8, %%mm2\n\t"        // %mm2 = 0Y0Y0Y0Y
			"packuswb %%mm2, %%mm3\n\t"  // %mm3 = ????YYYY
			"pand %%mm7, %%mm3\n\t"      // %mm3 = 0000YYYY

			// 8 pixels samenvoegen
			"por %%mm3, %%mm1\n\t"       // samenvoegen

			"movq %%mm1, (%%ebx)\n\t"    // ..en wegschrijven


			// volgende 4 pixels
			"psrlw $8, %%mm4\n\t"        // %mm4 = 0Y0Y0Y0Y
			"packuswb %%mm4, %%mm1\n\t"  // %mm1 = ????YYYY
			"psrlq $32, %%mm1\n\t"	     // %mm1 = YYYY0000

			// laatste 4 pixels
			"psrlw $8, %%mm6\n\t"        // %mm6 = 0Y0Y0Y0Y
			"packuswb %%mm6, %%mm3\n\t"  // %mm3 = ????YYYY
			"pand %%mm7, %%mm3\n\t"      // %mm3 = 0000YYYY

			// weer 8 pixels samenvoegen
			"por %%mm3, %%mm1\n\t"       // samenvoegen

			"movq %%mm1, 8(%%ebx)\n\t"   // ..en wegschrijven

			"add $32, %%eax\n\t"         // op naar de volgende 16 pixels...
			"add $16, %%ebx\n\t"

			"dec %%ecx\n\t"              // geen loop gebruiken; is te traag
			"jnz .L99\n\t"

			"emms\n\t"
			
			"pop %%ecx\n\t"
			"pop %%ebx\n\t"

			:"=m"(YUV)     // %0 -> %eax
			:"m"(RGB),     // %1 -> %ebx
			"m"(NumPixels) // %2 -> %ecx
	);

	return 0;
}

