#!/bin/sh
#
# Transforms all .port and .component files in the directory
#

. ${HOME}/.cocomposerc
JAVA="java"
TRANSFORM="${JAVA} -classpath ${COCOMPOSE_HOME}/output/SEESCOA/component.jar component.parser.Transformer"
PORTS=`find *.port`
COMPONENTS=`find *.component`

for FILE in ${PORTS}; do
  echo "Transforming ${FILE}..."
  FILE=`basename ${FILE} .port`
  ${TRANSFORM} ${FILE}
done
for FILE in ${COMPONENTS}; do
  echo "Transforming ${FILE}..."
  FILE=`basename ${FILE} .component`
  ${TRANSFORM} ${FILE}
done
