
package testcases.scss;

class Sony {

    // Bandbreedte die de camera mag gebruiken: 100, 200 of 400 Mbps
    static final int    SPEED_100=0;
    static final int    SPEED_200=1;
    static final int    SPEED_400=2;    

    // Framerate in beeldjes per seconde: 1.875, 3.75, 7.5, 15, 30 of 60
    static final int    FRAMERATE_1_875=0;
    static final int    FRAMERATE_3_75=1;
    static final int    FRAMERATE_7_5=2;
    static final int    FRAMERATE_15=3;
    static final int    FRAMERATE_30=4;
    static final int    FRAMERATE_60=5;

    // Beeldgrootte en codering (SONY ondersteunt enkel het YUV-formaat)
    static final int    MODE_160x120_YUV444=0;
    static final int    MODE_320x240_YUV422=1;
    static final int    MODE_640x480_YUV411=2;
    static final int    MODE_640x480_YUV422=3;
    static final int    MODE_640x480_RGB=4;
    static final int    MODE_640x480_MONO=5;

    static final int    FORMAT_VGA_NONCOMPRESSED=0;
    static final int    FORMAT_SVGA_NONCOMPRESSED_1=1;
    static final int    FORMAT_SVGA_NONCOMPRESSED_2=2;
    static final int    FORMAT_RESERVED_1=3;
    static final int    FORMAT_RESERVED_2=4;
    static final int    FORMAT_RESERVED_3=5;
    static final int    FORMAT_STILL_IMAGE=6;
    static final int    FORMAT_SCALABLE_IMAGE_SIZE=7;

    static final int    COLOR_FORMAT7_MONO8=0;
    static final int    COLOR_FORMAT7_YUV411=1;
    static final int    COLOR_FORMAT7_YUV422=2;
    static final int    COLOR_FORMAT7_YUV444=3;
    static final int    COLOR_FORMAT7_RGB8=4;
    static final int    COLOR_FORMAT7_MONO16=5;
    static final int    COLOR_FORMAT7_RGB16=6;

    static final int    MODE_FORMAT7_0=0;
    static final int    MODE_FORMAT7_1=1;
    static final int    MODE_FORMAT7_2=2;
    static final int    MODE_FORMAT7_3=3;
    static final int    MODE_FORMAT7_4=4;
    static final int    MODE_FORMAT7_5=5;
    static final int    MODE_FORMAT7_6=6;
    static final int    MODE_FORMAT7_7=7;

    static final int    TRIGGER_MODE_0=0;
    static final int    TRIGGER_MODE_1=1;
    static final int    TRIGGER_MODE_2=2;
    static final int    TRIGGER_MODE_3=3;

    static final long ROM_BUS_INFO_BLOCK=0x400;
    static final long ROM_ROOT_DIRECTORY=0x414;
    static final long REG_CAMERA_INITIALIZE=0x000;
    static final long REG_CAMERA_V_FORMAT_INQ=0x100;
    static final long REG_CAMERA_V_MODE_INQ_BASE=0x180;
    static final long REG_CAMERA_V_RATE_INQ_BASE=0x200;
    static final long REG_CAMERA_V_REV_INQ_BASE=0x2C0;
    static final long REG_CAMERA_V_CSR_INQ_BASE=0x2E0;
    static final long REG_CAMERA_BASIC_FUNC_INQ=0x400;
    static final long REG_CAMERA_FEATURE_HI_INQ=0x404;
    static final long REG_CAMERA_FEATURE_LO_INQ=0x408;
    static final long REG_CAMERA_ADV_FEATURE_INQ=0x480;
    static final long REG_CAMERA_FEATURE_HI_BASE_INQ=0x500;
    static final long REG_CAMERA_FEATURE_LO_BASE_INQ=0x580;
    static final long REG_CAMERA_FRAME_RATE=0x600;
    static final long REG_CAMERA_VIDEO_MODE=0x604;
    static final long REG_CAMERA_VIDEO_FORMAT=0x608;
    static final long REG_CAMERA_ISO_DATA=0x60C;
    static final long REG_CAMERA_POWER=0x610;
    static final long REG_CAMERA_ISO_EN=0x614;
    static final long REG_CAMERA_MEMORY_SAVE=0x618;
    static final long REG_CAMERA_ONE_SHOT=0x61C;
    static final long REG_CAMERA_MEM_SAVE_CH=0x620;
    static final long REG_CAMERA_CUR_MEM_CH=0x624;
    static final long REG_CAMERA_FEATURE_HI_BASE=0x800;
    static final long REG_CAMERA_FEATURE_LO_BASE=0x880;
    static final long REG_CAMERA_BRIGHTNESS=0x800;
    static final long REG_CAMERA_EXPOSURE=0x804;
    static final long REG_CAMERA_SHARPNESS=0x808;
    static final long REG_CAMERA_WHITE_BALANCE=0x80C;
    static final long REG_CAMERA_HUE=0x810;
    static final long REG_CAMERA_SATURATION=0x814;
    static final long REG_CAMERA_GAMMA=0x818;
    static final long REG_CAMERA_SHUTTER=0x81C;
    static final long REG_CAMERA_GAIN=0x820;
    static final long REG_CAMERA_IRIS=0x824;
    static final long REG_CAMERA_FOCUS=0x828;
    static final long REG_CAMERA_TEMPERATURE=0x82C;
    static final long REG_CAMERA_TRIGGER_MODE=0x830;
    static final long REG_CAMERA_ZOOM=0x880;
    static final long REG_CAMERA_PAN=0x884;
    static final long REG_CAMERA_TILT=0x888;
    static final long REG_CAMERA_OPTICAL_FILTER=0x88C;
    static final long REG_CAMERA_CAPTURE_SIZE=0x8C0;
    static final long REG_CAMERA_CAPTURE_QUALITY=0x8C4;

    public native void init(int format, int mode, int speed, int framerate);
    public native void startiso();
    public native void stopiso();
    public native void singlecapture(int beeld, boolean bw);
    public native void getimage(byte[] image, int offset, boolean bw, int beeld);
    public native int setfeature(long feature, int value);
    public native int getfeature(long feature);
    public Sony(int format, int mode, int speed, int framerate){init(format, mode, speed, framerate);}
    static {System.loadLibrary("sony");}
}
