package testcases.scss.motiondetection;

public class FramerateMDCommand extends MDCommand{

    public FramerateMDCommand(CameraMD cMD){
	super(cMD);
    }

    public void execute(Object o){
	try{
	    super.execute(o);
	    Integer i = (Integer)o;
	    if(i.intValue()>0){
		getCameraMD().setFrameRate(i.intValue());
	    }
	}catch(ClassCastException cce){
	    // the specs weren't followed... just return
	    return;
	}
    }

    public Object getValue(){
	return new Integer(getCameraMD().getFrameRate());
    }

    public String toString(){
	return "Framerate Command";
    }

}
