package testcases.scss.motiondetection;

public class TriggerDurationMDCommand extends MDCommand{

    public TriggerDurationMDCommand(CameraMD cMD){
	super(cMD);
    }

    public void execute(Object o){
	try{
	    Integer[] iV = (Integer[])o;
	    getCameraMD().setTimeBeforeSwitchTriggering(iV[0].intValue());
	    getCameraMD().setTimeAfterSwitchTriggering(iV[1].intValue());
	}catch(ClassCastException cce){
	    // the specs weren't followed... just return
	    return;
	}
    }

    public Object getValue(){
	Integer[] iV = new Integer[2];
	iV[0] = new Integer(getCameraMD().getTimeBeforeSwitchTriggering());
	iV[1] = new Integer(getCameraMD().getTimeAfterSwitchTriggering());
	return iV;
    }

}
